import { __assign, __rest } from "tslib";
import { aggregateToQuery } from "./aggregateToQuery";
import { RTKLoader } from "./RTKLoader";
export var createUseLoader = function (createUseLoaderArgs) {
    var useLoader = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var loaderRes = createUseLoaderArgs.useQueries.apply(createUseLoaderArgs, args);
        var queriesList = loaderRes.queries
            ? Object.keys(loaderRes.queries).map(function (key) { return loaderRes.queries[key]; })
            : [];
        var aggregatedQuery = aggregateToQuery(queriesList);
        if (aggregatedQuery.isSuccess || queriesList.length === 0) {
            var data = createUseLoaderArgs.transform
                ? createUseLoaderArgs.transform(loaderRes)
                : loaderRes;
            return __assign(__assign({}, aggregatedQuery), { isSuccess: true, data: data, currentData: data, originalArgs: args });
        }
        return aggregatedQuery;
    };
    useLoader.original_args = createUseLoaderArgs;
    return useLoader;
};
export var createLoader = function (createLoaderArgs) {
    var _a, _b;
    var useLoader = createUseLoader({
        useQueries: (_a = createLoaderArgs.useQueries) !== null && _a !== void 0 ? _a : (function () { return ({}); }),
        transform: createLoaderArgs.transform
    });
    var loader = {
        useLoader: useLoader,
        onLoading: createLoaderArgs.onLoading,
        onError: createLoaderArgs.onError,
        onFetching: createLoaderArgs.onFetching,
        whileFetching: createLoaderArgs.whileFetching,
        queriesArg: createLoaderArgs.queriesArg,
        LoaderComponent: (_b = createLoaderArgs.loaderComponent) !== null && _b !== void 0 ? _b : RTKLoader,
        extend: function (_a) {
            var useQueries = _a.useQueries, transform = _a.transform, loaderArgs = __rest(_a, ["useQueries", "transform"]);
            var extendedLoader = __assign(__assign({}, this), loaderArgs);
            if (useQueries) {
                var newUseLoader = createUseLoader({
                    useQueries: useQueries,
                    transform: transform
                });
                extendedLoader.useLoader = newUseLoader;
            }
            else if (transform) {
                var newUseLoader = createUseLoader({
                    useQueries: extendedLoader.useLoader.original_args.useQueries,
                    transform: transform
                });
                extendedLoader.useLoader = newUseLoader;
            }
            return extendedLoader;
        }
    };
    return loader;
};
//# sourceMappingURL=createLoader.js.map